diff --git a/drivers/bus/dpaa/meson.build b/drivers/bus/dpaa/meson.build
index c2cffa4943..a3471403e2 100644
--- a/drivers/bus/dpaa/meson.build
+++ b/drivers/bus/dpaa/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 deps += ['common_dpaax', 'eventdev']
diff --git a/drivers/bus/fslmc/meson.build b/drivers/bus/fslmc/meson.build
index eb8874a5ac..260e7ef712 100644
--- a/drivers/bus/fslmc/meson.build
+++ b/drivers/bus/fslmc/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 deps += ['common_dpaax', 'eventdev', 'kvargs']
diff --git a/drivers/bus/vmbus/meson.build b/drivers/bus/vmbus/meson.build
index b90e74d69c..47e26703aa 100644
--- a/drivers/bus/vmbus/meson.build
+++ b/drivers/bus/vmbus/meson.build
@@ -20,5 +20,5 @@ if is_linux
 	includes += include_directories('linux')
 else
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
diff --git a/drivers/common/dpaax/meson.build b/drivers/common/dpaax/meson.build
index 0b8bf7bd51..4535482701 100644
--- a/drivers/common/dpaax/meson.build
+++ b/drivers/common/dpaax/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 sources = files('dpaax_iova_table.c', 'dpaa_of.c', 'caamflib.c')
diff --git a/drivers/crypto/caam_jr/meson.build b/drivers/crypto/caam_jr/meson.build
index f8b5250a93..68e6b1d44c 100644
--- a/drivers/crypto/caam_jr/meson.build
+++ b/drivers/crypto/caam_jr/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 deps += ['bus_vdev', 'bus_dpaa', 'security']
diff --git a/drivers/crypto/ccp/meson.build b/drivers/crypto/ccp/meson.build
index 6f7217adbf..a0e0b379eb 100644
--- a/drivers/crypto/ccp/meson.build
+++ b/drivers/crypto/ccp/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 dep = dependency('libcrypto', required: false)
 if not dep.found()
diff --git a/drivers/crypto/dpaa2_sec/meson.build b/drivers/crypto/dpaa2_sec/meson.build
index cb1c2d0492..69c7264e5a 100644
--- a/drivers/crypto/dpaa2_sec/meson.build
+++ b/drivers/crypto/dpaa2_sec/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 deps += ['security', 'mempool_dpaa2']
diff --git a/drivers/crypto/dpaa_sec/meson.build b/drivers/crypto/dpaa_sec/meson.build
index 7d422d8d55..c391a26711 100644
--- a/drivers/crypto/dpaa_sec/meson.build
+++ b/drivers/crypto/dpaa_sec/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 deps += ['bus_dpaa', 'mempool_dpaa', 'security']
diff --git a/drivers/crypto/octeontx/meson.build b/drivers/crypto/octeontx/meson.build
index d6939720d8..88c812d3fa 100644
--- a/drivers/crypto/octeontx/meson.build
+++ b/drivers/crypto/octeontx/meson.build
@@ -2,7 +2,7 @@
 # Copyright(c) 2018 Cavium, Inc
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 deps += ['bus_pci']
diff --git a/drivers/event/dlb/meson.build b/drivers/event/dlb/meson.build
index 7d40c163fc..bc158d2e0a 100644
--- a/drivers/event/dlb/meson.build
+++ b/drivers/event/dlb/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux or not dpdk_conf.has('RTE_ARCH_X86_64')
         build = false
-        reason = 'only supported on ARCH_X86_64 Linux'
+        reason = 'only supported on x86_64 Linux'
         subdir_done()
 endif
 
diff --git a/drivers/event/dlb2/meson.build b/drivers/event/dlb2/meson.build
index bcda3dd571..f22638b8e4 100644
--- a/drivers/event/dlb2/meson.build
+++ b/drivers/event/dlb2/meson.build
@@ -4,7 +4,7 @@
 
 if not is_linux or not dpdk_conf.has('RTE_ARCH_X86_64')
         build = false
-        reason = 'only supported on ARCH_X86_64 Linux'
+        reason = 'only supported on x86_64 Linux'
         subdir_done()
 endif
 
diff --git a/drivers/event/dpaa/meson.build b/drivers/event/dpaa/meson.build
index 9abb75e3e9..85105a210b 100644
--- a/drivers/event/dpaa/meson.build
+++ b/drivers/event/dpaa/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 deps += ['net_dpaa', 'crypto_dpaa_sec']
 sources = files('dpaa_eventdev.c')
diff --git a/drivers/event/dpaa2/meson.build b/drivers/event/dpaa2/meson.build
index 4ead7bb3e9..21aff6276a 100644
--- a/drivers/event/dpaa2/meson.build
+++ b/drivers/event/dpaa2/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 deps += ['bus_vdev', 'net_dpaa2', 'crypto_dpaa2_sec']
 sources = files('dpaa2_hw_dpcon.c',
diff --git a/drivers/mempool/dpaa/meson.build b/drivers/mempool/dpaa/meson.build
index 754e6397f2..09f5295d95 100644
--- a/drivers/mempool/dpaa/meson.build
+++ b/drivers/mempool/dpaa/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 deps += ['bus_dpaa']
diff --git a/drivers/mempool/dpaa2/meson.build b/drivers/mempool/dpaa2/meson.build
index ed55c0d437..17ad0a8ea7 100644
--- a/drivers/mempool/dpaa2/meson.build
+++ b/drivers/mempool/dpaa2/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 deps += ['bus_fslmc']
diff --git a/drivers/meson.build b/drivers/meson.build
index 4bb7e92183..bc6833c65a 100644
--- a/drivers/meson.build
+++ b/drivers/meson.build
@@ -77,7 +77,7 @@ foreach subpath:subdirs
 
 		if disabled_drivers.contains(drv_path)
 			build = false
-			reason = 'Explicitly disabled via build config'
+			reason = 'explicitly disabled via build config'
 		else
 			# pull in driver directory which should update all the local variables
 			subdir(drv_path)
@@ -90,7 +90,7 @@ foreach subpath:subdirs
 			foreach d:deps
 				if not is_variable('shared_rte_' + d)
 					build = false
-					reason = 'Missing internal dependency, "@0@"'.format(d)
+					reason = 'missing internal dependency, "@0@"'.format(d)
 					message('Disabling @1@ [@2@]: missing internal dependency "@0@"'
 							.format(d, name, 'drivers/' + drv_path))
 				else
diff --git a/drivers/net/af_packet/meson.build b/drivers/net/af_packet/meson.build
index a7f392ea1f..50a2f05d34 100644
--- a/drivers/net/af_packet/meson.build
+++ b/drivers/net/af_packet/meson.build
@@ -3,6 +3,6 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 sources = files('rte_eth_af_packet.c')
diff --git a/drivers/net/avp/meson.build b/drivers/net/avp/meson.build
index 7c6b964acb..61c8d5b9f0 100644
--- a/drivers/net/avp/meson.build
+++ b/drivers/net/avp/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 sources = files('avp_ethdev.c')
 headers = files('rte_avp_common.h', 'rte_avp_fifo.h')
diff --git a/drivers/net/axgbe/meson.build b/drivers/net/axgbe/meson.build
index 86873b7ef9..198e198767 100644
--- a/drivers/net/axgbe/meson.build
+++ b/drivers/net/axgbe/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 sources = files('axgbe_ethdev.c',
diff --git a/drivers/net/dpaa/meson.build b/drivers/net/dpaa/meson.build
index ecb06ea65e..0f72730b03 100644
--- a/drivers/net/dpaa/meson.build
+++ b/drivers/net/dpaa/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 deps += ['mempool_dpaa']
 
diff --git a/drivers/net/dpaa2/meson.build b/drivers/net/dpaa2/meson.build
index 7e43553a3b..844dd25159 100644
--- a/drivers/net/dpaa2/meson.build
+++ b/drivers/net/dpaa2/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 deps += ['mempool_dpaa2']
diff --git a/drivers/net/enetc/meson.build b/drivers/net/enetc/meson.build
index bea54bea88..850307c04e 100644
--- a/drivers/net/enetc/meson.build
+++ b/drivers/net/enetc/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 
 deps += ['common_dpaax']
diff --git a/drivers/net/hns3/meson.build b/drivers/net/hns3/meson.build
index 0ad28e59bf..45cee34d9d 100644
--- a/drivers/net/hns3/meson.build
+++ b/drivers/net/hns3/meson.build
@@ -9,7 +9,7 @@ endif
 
 if arch_subdir != 'x86' and arch_subdir != 'arm' or not dpdk_conf.get('RTE_ARCH_64')
 	build = false
-	reason = 'only supported on x86_64 and arm64'
+	reason = 'only supported on x86_64 and aarch64'
 	subdir_done()
 endif
 
diff --git a/drivers/net/nfp/meson.build b/drivers/net/nfp/meson.build
index 24a9a6da9c..21b20c9ac9 100644
--- a/drivers/net/nfp/meson.build
+++ b/drivers/net/nfp/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux or not dpdk_conf.get('RTE_ARCH_64')
 	build = false
-	reason = 'only supported on 64-bit linux'
+	reason = 'only supported on 64-bit Linux'
 endif
 sources = files('nfpcore/nfp_cpp_pcie_ops.c',
 	'nfpcore/nfp_nsp.c',
diff --git a/drivers/net/softnic/meson.build b/drivers/net/softnic/meson.build
index b96ae6ba9e..e31bdece7b 100644
--- a/drivers/net/softnic/meson.build
+++ b/drivers/net/softnic/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 headers = files('rte_eth_softnic.h')
 sources = files('rte_eth_softnic_tm.c',
diff --git a/drivers/net/tap/meson.build b/drivers/net/tap/meson.build
index c1cdf9e673..d51bd3190d 100644
--- a/drivers/net/tap/meson.build
+++ b/drivers/net/tap/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 sources = files(
 	'rte_eth_tap.c',
diff --git a/drivers/net/vdev_netvsc/meson.build b/drivers/net/vdev_netvsc/meson.build
index 58b0012ed9..49d3a2c7bb 100644
--- a/drivers/net/vdev_netvsc/meson.build
+++ b/drivers/net/vdev_netvsc/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 sources = files('vdev_netvsc.c')
 
diff --git a/lib/librte_kni/meson.build b/lib/librte_kni/meson.build
index ad598bb3d0..55e47df413 100644
--- a/lib/librte_kni/meson.build
+++ b/lib/librte_kni/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux or not dpdk_conf.get('RTE_ARCH_64')
 	build = false
-	reason = 'only supported on 64-bit linux'
+	reason = 'only supported on 64-bit Linux'
 endif
 sources = files('rte_kni.c')
 headers = files('rte_kni.h', 'rte_kni_common.h')
diff --git a/lib/librte_power/meson.build b/lib/librte_power/meson.build
index 78c031c943..4b4cf1b90b 100644
--- a/lib/librte_power/meson.build
+++ b/lib/librte_power/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 sources = files('rte_power.c', 'power_acpi_cpufreq.c',
 		'power_kvm_vm.c', 'guest_channel.c',
diff --git a/lib/librte_vhost/meson.build b/lib/librte_vhost/meson.build
index cc9aa65c67..6185deab33 100644
--- a/lib/librte_vhost/meson.build
+++ b/lib/librte_vhost/meson.build
@@ -3,7 +3,7 @@
 
 if not is_linux
 	build = false
-	reason = 'only supported on linux'
+	reason = 'only supported on Linux'
 endif
 if has_libnuma == 1
 	dpdk_conf.set10('RTE_LIBRTE_VHOST_NUMA', true)